import os
import json
import pytest
from apiclient.client import api_client
from apiclient.config import get_cfg
from apiclient.oauth_helper import get_legacy_token


ENV = 'qa'
CFG = get_cfg(ENV)

CWD = os.path.dirname(os.path.realpath(__file__))


@pytest.fixture
def api_call():
    token = get_legacy_token(ENV)
    api_call = {
        "token": token,
        "method": "GET",
        "url": CFG["api_url"] + '/data-delivery/role',
        "headers": {'Content-Type': 'application/json'},
        "body": {"application_id": 1}
    }
    return api_call


def test_datadelivery_role_get(request, api_call):

    expected_response = get_expected_response(request.node.name)
    actual_response = api_client(api_call)

    assert json.dumps(actual_response, indent=4) == json.dumps(expected_response, indent=4)


####
# HELPERS
####
def get_expected_response(test_name):
    expected_response_file = test_name + ".json"
    with open(os.path.join(CWD, 'expected_responses', expected_response_file), 'r') as file:
        expected_response = json.load(file)
        return expected_response
